/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import com.ibm.etools.c.CArray;
import com.ibm.etools.c.CBehavioralFeature;
import com.ibm.etools.c.CClassifier;
import com.ibm.etools.c.CDatatype;
import com.ibm.etools.c.CDerivableType;
import com.ibm.etools.c.CDerived;
import com.ibm.etools.c.CEnumerator;
import com.ibm.etools.c.CField;
import com.ibm.etools.c.CFunction;
import com.ibm.etools.c.CInitializer;
import com.ibm.etools.c.CPackage;
import com.ibm.etools.c.CParameter;
import com.ibm.etools.c.CPointer;
import com.ibm.etools.c.CSourceText;
import com.ibm.etools.c.CStruct;
import com.ibm.etools.c.CStructuralFeature;
import com.ibm.etools.c.CStructureContents;
import com.ibm.etools.c.CStructured;
import com.ibm.etools.c.CTypedElement;
import com.ibm.etools.c.CTypedef;
import com.ibm.etools.c.CUnion;
import com.ibm.etools.tdlang.TDLangClassifier;
import com.ibm.etools.tdlang.TDLangComposedType;
import com.ibm.etools.tdlang.TDLangElement;
import com.ibm.etools.tdlang.TDLangModelElement;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory </b> for the model. It
 * provides an adapter <code>createXXX</code> method for each class of the
 * model. <!-- end-user-doc -->
 * 
 * @see com.ibm.etools.c.CPackage
 * @generated
 */
public class CAdapterFactory extends AdapterFactoryImpl {
    /**
     * The cached model package. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected static CPackage modelPackage;

    /**
     * Creates an instance of the adapter factory. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    public CAdapterFactory() {
        if (modelPackage == null) {
            modelPackage = CPackage.eINSTANCE;
        }
    }

    /**
     * Returns whether this factory is applicable for the type of the object.
     * <!-- begin-user-doc --> This implementation returns <code>true</code>
     * if the object is either the model's package or is an instance object of
     * the model. <!-- end-user-doc -->
     * 
     * @return whether this factory is applicable for the type of the object.
     * @generated
     */
    public boolean isFactoryForType(Object object) {
        if (object == modelPackage) {
            return true;
        }
        if (object instanceof EObject) {
            return ((EObject) object).eClass().getEPackage() == modelPackage;
        }
        return false;
    }

    /**
     * The switch the delegates to the <code>createXXX</code> methods. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected CSwitch modelSwitch = new CSwitch() {
        public Object caseCClassifier(CClassifier object) {
            return createCClassifierAdapter();
        }

        public Object caseCStructured(CStructured object) {
            return createCStructuredAdapter();
        }

        public Object caseCStruct(CStruct object) {
            return createCStructAdapter();
        }

        public Object caseCUnion(CUnion object) {
            return createCUnionAdapter();
        }

        public Object caseCBehavioralFeature(CBehavioralFeature object) {
            return createCBehavioralFeatureAdapter();
        }

        public Object caseCTypedElement(CTypedElement object) {
            return createCTypedElementAdapter();
        }

        public Object caseCStructuralFeature(CStructuralFeature object) {
            return createCStructuralFeatureAdapter();
        }

        public Object caseCParameter(CParameter object) {
            return createCParameterAdapter();
        }

        public Object caseCDatatype(CDatatype object) {
            return createCDatatypeAdapter();
        }

        public Object caseCTypedef(CTypedef object) {
            return createCTypedefAdapter();
        }

        public Object caseCDerived(CDerived object) {
            return createCDerivedAdapter();
        }

        public Object caseCArray(CArray object) {
            return createCArrayAdapter();
        }

        public Object caseCPointer(CPointer object) {
            return createCPointerAdapter();
        }

        public Object caseCEnumerator(CEnumerator object) {
            return createCEnumeratorAdapter();
        }

        public Object caseCField(CField object) {
            return createCFieldAdapter();
        }

        public Object caseCFunction(CFunction object) {
            return createCFunctionAdapter();
        }

        public Object caseCInitializer(CInitializer object) {
            return createCInitializerAdapter();
        }

        public Object caseCDerivableType(CDerivableType object) {
            return createCDerivableTypeAdapter();
        }

        public Object caseCStructureContents(CStructureContents object) {
            return createCStructureContentsAdapter();
        }

        public Object caseCSourceText(CSourceText object) {
            return createCSourceTextAdapter();
        }

        public Object caseTDLangModelElement(TDLangModelElement object) {
            return createTDLangModelElementAdapter();
        }

        public Object caseTDLangClassifier(TDLangClassifier object) {
            return createTDLangClassifierAdapter();
        }

        public Object caseTDLangComposedType(TDLangComposedType object) {
            return createTDLangComposedTypeAdapter();
        }

        public Object caseTDLangElement(TDLangElement object) {
            return createTDLangElementAdapter();
        }

        public Object defaultCase(EObject object) {
            return createEObjectAdapter();
        }
    };

    /**
     * Creates an adapter for the <code>target</code>. <!-- begin-user-doc
     * --> <!-- end-user-doc -->
     * 
     * @param target
     *            the object to adapt.
     * @return the adapter for the <code>target</code>.
     * @generated
     */
    public Adapter createAdapter(Notifier target) {
        return (Adapter) modelSwitch.doSwitch((EObject) target);
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CClassifier <em>Classifier</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CClassifier
     * @generated
     */
    public Adapter createCClassifierAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CStructured <em>Structured</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CStructured
     * @generated
     */
    public Adapter createCStructuredAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CStruct <em>Struct</em>}'. <!-- begin-user-doc
     * --> This default implementation returns null so that we can easily ignore
     * cases; it's useful to ignore a case when inheritance will catch all the
     * cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CStruct
     * @generated
     */
    public Adapter createCStructAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CUnion <em>Union</em>}'. <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore
     * cases; it's useful to ignore a case when inheritance will catch all the
     * cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CUnion
     * @generated
     */
    public Adapter createCUnionAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CBehavioralFeature <em>Behavioral Feature</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CBehavioralFeature
     * @generated
     */
    public Adapter createCBehavioralFeatureAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CTypedElement <em>Typed Element</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CTypedElement
     * @generated
     */
    public Adapter createCTypedElementAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CStructuralFeature <em>Structural Feature</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CStructuralFeature
     * @generated
     */
    public Adapter createCStructuralFeatureAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CParameter <em>Parameter</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CParameter
     * @generated
     */
    public Adapter createCParameterAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CDatatype <em>Datatype</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CDatatype
     * @generated
     */
    public Adapter createCDatatypeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CTypedef <em>Typedef</em>}'. <!-- begin-user-doc
     * --> This default implementation returns null so that we can easily ignore
     * cases; it's useful to ignore a case when inheritance will catch all the
     * cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CTypedef
     * @generated
     */
    public Adapter createCTypedefAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CDerived <em>Derived</em>}'. <!-- begin-user-doc
     * --> This default implementation returns null so that we can easily ignore
     * cases; it's useful to ignore a case when inheritance will catch all the
     * cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CDerived
     * @generated
     */
    public Adapter createCDerivedAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CArray <em>Array</em>}'. <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore
     * cases; it's useful to ignore a case when inheritance will catch all the
     * cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CArray
     * @generated
     */
    public Adapter createCArrayAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CPointer <em>Pointer</em>}'. <!-- begin-user-doc
     * --> This default implementation returns null so that we can easily ignore
     * cases; it's useful to ignore a case when inheritance will catch all the
     * cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CPointer
     * @generated
     */
    public Adapter createCPointerAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CEnumerator <em>Enumerator</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CEnumerator
     * @generated
     */
    public Adapter createCEnumeratorAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CField <em>Field</em>}'. <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore
     * cases; it's useful to ignore a case when inheritance will catch all the
     * cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CField
     * @generated
     */
    public Adapter createCFieldAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CFunction <em>Function</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CFunction
     * @generated
     */
    public Adapter createCFunctionAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CInitializer <em>Initializer</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CInitializer
     * @generated
     */
    public Adapter createCInitializerAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CDerivableType <em>Derivable Type</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CDerivableType
     * @generated
     */
    public Adapter createCDerivableTypeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CStructureContents <em>Structure Contents</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CStructureContents
     * @generated
     */
    public Adapter createCStructureContentsAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.c.CSourceText <em>Source Text</em>}'. <!--
     * begin-user-doc --> This default implementation returns null so that we
     * can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.c.CSourceText
     * @generated
     */
    public Adapter createCSourceTextAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.tdlang.TDLangModelElement <em>TD Lang Model Element</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.tdlang.TDLangModelElement
     * @generated
     */
    public Adapter createTDLangModelElementAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.tdlang.TDLangClassifier <em>TD Lang Classifier</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.tdlang.TDLangClassifier
     * @generated
     */
    public Adapter createTDLangClassifierAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.tdlang.TDLangComposedType <em>TD Lang Composed Type</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.tdlang.TDLangComposedType
     * @generated
     */
    public Adapter createTDLangComposedTypeAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '
     * {@link com.ibm.etools.tdlang.TDLangElement <em>TD Lang Element</em>}'.
     * <!-- begin-user-doc --> This default implementation returns null so that
     * we can easily ignore cases; it's useful to ignore a case when inheritance
     * will catch all the cases anyway. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @see com.ibm.etools.tdlang.TDLangElement
     * @generated
     */
    public Adapter createTDLangElementAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for the default case. <!-- begin-user-doc --> This
     * default implementation returns null. <!-- end-user-doc -->
     * 
     * @return the new adapter.
     * @generated
     */
    public Adapter createEObjectAdapter() {
        return null;
    }

} //CAdapterFactory
